<?php

namespace Drupal\preprocessors_example\Plugin\preprocessors;

use Drupal\preprocessors\PluginManager\PreprocessorsPluginManager\PreprocessorPluginBase;

/**
 * Provide plugin to alter variables for nodes.
 *
 * This one provides an example of setting weight. The weight is just set to 0
 * though! It's the default weight, but can be set to whatever you want.
 *
 * The other plugin discovered through Yaml has a higher weight and should run
 * AFTER this one!
 *
 * Weight only applies to two plugins targeting the same theme hook.
 *
 * @noinspection
 *   AnnotationMissingUseInspection
 *
 * @Preprocessor(
 *   id = "preprocessors_example.node_preprocessor",
 *   theme_hook = "node",
 *   weight = 0
 * )
 *
 * @package Drupal\preprocessors_example\Plugin\Preprocessor
 */
final class NodePreprocessor extends PreprocessorPluginBase {

  /**
   * Add personal tweaks to variables in this function.
   *
   * {@inheritdoc}
   */
  public function preprocess(&$variables, $hook, $info): void {
    $variables['hello'] = 'world';
  }

}
