<?php

namespace Drupal\preprocessors_examples\Plugin\preprocessors;

use Drupal\preprocessors\PluginManager\PreprocessorsPluginManager\PreprocessorPluginBase;

/**
 * Provide plugin to alter variables for "page" type nodes.
 *
 * This one has an example of adding the 'themes' property, which only activates
 * this preprocessor in the provided themes. Change them to your liking.
 *
 * @noinspection
 *   AnnotationMissingUseInspection
 *
 * @Preprocessor(
 *   id = "preprocessors_example.page_preprocessor",
 *   theme_hook = "page",
 *   themes = {
 *      CUSTOM_THEME_1,
 *      CUSTOM_THEME_2
 *   }
 * )
 *
 * @package Drupal\preprocessors_example\Plugin\Preprocessor
 */
final class PagePreprocessor extends PreprocessorPluginBase {

  /**
   * Add personal tweaks to variables in this function.
   *
   * {@inheritdoc}
   */
  public function preprocess(&$variables, $hook, $info): void {
    $variables['hello'] = 'world';
  }

}
